package xmlwriter;


import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.net.URL;
import java.util.List;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author petr
 */
public class XMLObjectWriter {
    PrintWriter writer;
    /**
     * Jméno root elementu
     */
    String root;
    /**
     * Jméno DTD souboru
     */
    String dtd;

    public XMLObjectWriter(String root, String dtd) {
        this.root = root;
        this.dtd = dtd;
    }

  public void openFile(String output) throws FileNotFoundException, UnsupportedEncodingException {
        OutputStreamWriter owriter = new OutputStreamWriter(new FileOutputStream(output), "UTF-8");
        writer = new PrintWriter(owriter);

        writer.format("<?xml version=\"1.0\" encoding=\"UTF-8\"?>%n%n");
        writer.format("<!DOCTYPE "+root+ " SYSTEM \"" + dtd + "\">%n%n");
        writer.printf("<" + root + ">%n");
  }

  public void writeAsXML(List<XMLarisable> obj) {
    for(XMLarisable x : obj) {
       writer.print(x.toXML());
    }
  }

  public void closeFile() {
        writer.printf("</" + root + ">%n");
        if(writer != null)
               writer.close();
  }
}